#include "jtraceAPI.h"
#include <stdio.h>
#include "colors.h"
#include <sys/ioctl.h>
#include <string.h>
#include "citadel.h"


// Sample plugin for JTrace API
// ----------------------------
//
// I made the API very simple but (hopefully) effective - q.v. the H file,
// which I've fully documented.
//
// Basically, you create a dylib, 
//
// Please direct any suggestions for improvements, or additional APIs
// you may want to me via NewAndroidBook.com
// 
//



extern int config_color (void);

int gColor ;

int citadeld_ioctl (int Exit, int Pid)
{


   static int mine = 0;

	char *ob = getOutputBuffer();

	int pos = 0;


   if (!Exit) {

 	int fd = (int) getRegValue(REG_ARG_0);
 	int code = (int) getRegValue(REG_ARG_1);

	char *devNode = getFDName(fd);
	if (devNode && strcmp (devNode, "/dev/citadel0") == 0)
	{
		uint64_t dgAddr;
		mine++;


		pos += sprintf(ob + pos, "---->ioctl (%d<%s>,", fd, devNode);
		switch (code) {
			case CITADEL_IOC_TPM_DATAGRAM:
				dgAddr = (struct citadel_ioc_tpm_datagram *)getRegValue(REG_ARG_2);

				
				if (dgAddr) { 
				struct citadel_ioc_tpm_datagram localDG;

				int rc=  readProcessMemory (Pid,  dgAddr, sizeof(struct citadel_ioc_tpm_datagram), &localDG);

				pos += sprintf(ob + pos, "CITADEL_IOC_TPM_DATAGRAM - cmd 0x%x, buf %d bytes@0x%llx\n", localDG.command, localDG.len, localDG.buf);

				if (localDG.len) {

					// Get the actual buffer..

					//@@TODO: could be too big!
					char *localBuf = alloca(localDG.len);
					if (localBuf) {
						rc=  readProcessMemory (Pid,  localDG.buf, localDG.len, localBuf);
						pos +=  hexDumpToBuffer (ob+pos,0 , localBuf, localDG.len, localDG.buf, 1);


					}
					else { printf("Can't allocate %d bytes!\n", localDG.len); }


				} // localDG.len
				}

				else {
				pos += sprintf(ob+pos, "CITADEL_IOC_TPM_DATAGRAM - NULL");

				}

				break;
			case CITADEL_IOC_RESET:
				pos +=sprintf(ob +pos,"CITADEL_IOC_RESET");
				break;

		default: pos += sprintf(ob + pos, "Code 0x%x (unknown - tell J!)", code);
		} // switch code
	}

		
	else {	// ! mine..

			return 2;

	    } // end switch

	} // end if !Exit

   	else{
		if (mine) {

				mine = 0;
 			int rc = (int) getRegValue(REG_ARG_0);

		}


	}
	updateOutputBufferPos(pos);
   	return 0;
} // ioctl




static int init = 0;
__attribute__((constructor)) void _init(void) {
	
	if (init) return;
	init++;	
	fprintf(stderr,"--LOADED citadeld plugin, hooking ioctl\n");
	gColor = config_color();

	//ignoreAllSyscalls();

	int rc= registerSyscallHandler ("ioctl", // char *SyscallName, // must exist or you'll get -1 
	        citadeld_ioctl,  // syscall_handler_func Handler,     // Your callback, per above
		0, //              int Bitness,     // 32, 64 or 0 (both)
		0);	//      int Flags);      // as per flags, above


}


#if 0

[root@localhost jtrace]# adb shell
sailfish:/ $ echo $$
7719

## Then run jtrace in another window, telling it to follow forks and load your plugin:


sailfish:/ # /data/local/tmp/jtrace64 -jdebug --plugin /data/local/tmp/plugin.so -p 7719 # your shell PID goes here
IN PLUGIN
Chaining handler for open as default
Chaining handler for openat as default
Loaded plugin: /data/local/tmp/plugin.so
...
----IN MY HANDLER for PID 7719 on entry!
FILENAME IS /etc/hosts..
Y IS /init.rc
REDIRECTING /etc/hosts to /init.rc!
----IN MY HANDLER for PID 7719 on exit!


# then in the original shell window, try:
sailfish:/ $ cat /etc/hosts
/system/bin/sh: cat: /init.rc: Permission denied

# :-)

# On x86_64 use the x86 plugin
/x86/jtrace.x86 --plugin ./x86/plugin.so /usr/bin/cat /etc/hosts 





#endif
