#include "jtraceAPI.h"
#include <stdio.h>
#include "colors.h"
#include <stdlib.h> // malloc,free
#include <sys/ioctl.h>
#include <string.h>
#include "msm_kgsl.h"
#include <drm/drm.h>


// Sample plugin for JTrace API
// ----------------------------
//
// I made the API very simple but (hopefully) effective - q.v. the H file,
// which I've fully documented.
//
// Basically, you create a dylib, 
//
// Please direct any suggestions for improvements, or additional APIs
// you may want to me via NewAndroidBook.com
// 
//


#if 0
31233(surfaceflinger): ioctl (15 </dev/kgsl-3d0>, 0x40200946 ...);
31233(surfaceflinger): ioctl (15 </dev/kgsl-3d0>, 0xc0200948 ...);
31233(surfaceflinger): ioctl (15 </dev/kgsl-3d0>, 0xc0300947 ...);
31233(surfaceflinger): ioctl (15 </dev/kgsl-3d0>, 0xc040094a ...);
31233(surfaceflinger): ioctl (15 </dev/kgsl-3d0>, 0xc0200933 ...);
#endif




extern int config_color (void);

int gColor ;


	
const char *kgslMemFlagsToText(uint64_t Flags){

	static char returned[1024];

	returned[0] = '\0';
	if (Flags &KGSL_MEMFLAGS_SECURE) strcat (returned, "SECURE,");
	if (Flags & KGSL_MEMFLAGS_GPUREADONLY) strcat (returned,"GPUREADONLY,");
	if (Flags & KGSL_MEMFLAGS_GPUWRITEONLY) strcat(returned,"GPUWRITEONLY,");
	if (Flags & KGSL_MEMFLAGS_FORCE_32BIT) strcat(returned,"FORCE32,");
	if (Flags & KGSL_MEMFLAGS_USE_CPU_MAP) strcat(returned,"USE_CPU_MAP,");
	if (Flags & KGSL_MEMFLAGS_SPARSE_PHYS) strcat(returned,"SPARSE_PHYS,");
	if (Flags & KGSL_MEMFLAGS_SPARSE_VIRT) strcat(returned,"SPARSE_VIRT,");
	if (Flags & KGSL_MEMFLAGS_IOCOHERENT) strcat(returned,"IOCOHERENT,");



	if (returned[0]) { returned[strlen(returned)-1] = '\0';}
	return (returned);

} //

int dri_ioctl (int Exit, int Pid)
{


   // @TODO: put this in TLS plugin private
   static int mine = 0;

	char *ob = getOutputBuffer();

	int pos = 0;


   if (!Exit) {

 	int fd = (int) getRegValue(REG_ARG_0);
 	uint64_t code = (uint64_t) getRegValue(REG_ARG_1);

	char *devNode = getFDName(fd);
	if (devNode && strstr (devNode, "/dev/dri/card"))
	{
		uint64_t dgAddr;
		mine++;


		pos += sprintf(ob + pos, "%sioctl%s(%d<%s>,", 
			gColor ? BLUE:"", gColor?NORMAL:"",fd, devNode);
		switch (code) {


		case DRM_IOCTL_VERSION: pos += sprintf(ob +pos, "DRM_IOCTL_VERSION");break;
		case DRM_IOCTL_GET_UNIQUE: pos += sprintf(ob +pos, "DRM_IOCTL_GET_UNIQUE");break;
		case DRM_IOCTL_GET_MAGIC: pos += sprintf(ob +pos, "DRM_IOCTL_GET_MAGIC");break;
		case DRM_IOCTL_IRQ_BUSID: pos += sprintf(ob +pos, "DRM_IOCTL_IRQ_BUSID");break;
		case DRM_IOCTL_GET_MAP: pos += sprintf(ob +pos, "DRM_IOCTL_GET_MAP");break;
		case DRM_IOCTL_GET_CLIENT: pos += sprintf(ob +pos, "DRM_IOCTL_GET_CLIENT");break;
		case DRM_IOCTL_GET_STATS: pos += sprintf(ob +pos, "DRM_IOCTL_GET_STATS");break;
		case DRM_IOCTL_SET_VERSION: pos += sprintf(ob +pos, "DRM_IOCTL_SET_VERSION");break;
		case DRM_IOCTL_MODESET_CTL: pos += sprintf(ob +pos, "DRM_IOCTL_MODESET_CTL");break;
		case DRM_IOCTL_GEM_CLOSE: pos += sprintf(ob +pos, "DRM_IOCTL_GEM_CLOSE");break;
		case DRM_IOCTL_GEM_FLINK: pos += sprintf(ob +pos, "DRM_IOCTL_GEM_FLINK");break;
		case DRM_IOCTL_GEM_OPEN: pos += sprintf(ob +pos, "DRM_IOCTL_GEM_OPEN");break;
		case DRM_IOCTL_GET_CAP: pos += sprintf(ob +pos, "DRM_IOCTL_GET_CAP");break;
		case DRM_IOCTL_SET_CLIENT_CAP: pos += sprintf(ob +pos, "DRM_IOCTL_SET_CLIENT_CAP");break;
		case DRM_IOCTL_SET_UNIQUE: pos += sprintf(ob +pos, "DRM_IOCTL_SET_UNIQUE");break;
		case DRM_IOCTL_AUTH_MAGIC: pos += sprintf(ob +pos, "DRM_IOCTL_AUTH_MAGIC");break;
		case DRM_IOCTL_BLOCK: pos += sprintf(ob +pos, "DRM_IOCTL_BLOCK");break;
		case DRM_IOCTL_UNBLOCK: pos += sprintf(ob +pos, "DRM_IOCTL_UNBLOCK");break;
		case DRM_IOCTL_CONTROL: pos += sprintf(ob +pos, "DRM_IOCTL_CONTROL");break;
		case DRM_IOCTL_ADD_MAP: pos += sprintf(ob +pos, "DRM_IOCTL_ADD_MAP");break;
		case DRM_IOCTL_ADD_BUFS: pos += sprintf(ob +pos, "DRM_IOCTL_ADD_BUFS");break;
		case DRM_IOCTL_MARK_BUFS: pos += sprintf(ob +pos, "DRM_IOCTL_MARK_BUFS");break;
		case DRM_IOCTL_INFO_BUFS: pos += sprintf(ob +pos, "DRM_IOCTL_INFO_BUFS");break;
		case DRM_IOCTL_MAP_BUFS: pos += sprintf(ob +pos, "DRM_IOCTL_MAP_BUFS");break;
		case DRM_IOCTL_FREE_BUFS: pos += sprintf(ob +pos, "DRM_IOCTL_FREE_BUFS");break;
		case DRM_IOCTL_RM_MAP: pos += sprintf(ob +pos, "DRM_IOCTL_RM_MAP");break;
		case DRM_IOCTL_SET_SAREA_CTX: pos += sprintf(ob +pos, "DRM_IOCTL_SET_SAREA_CTX");break;
		case DRM_IOCTL_GET_SAREA_CTX: pos += sprintf(ob +pos, "DRM_IOCTL_GET_SAREA_CTX");break;
		case DRM_IOCTL_SET_MASTER: pos += sprintf(ob +pos, "DRM_IOCTL_SET_MASTER");break;
		case DRM_IOCTL_DROP_MASTER: pos += sprintf(ob +pos, "DRM_IOCTL_DROP_MASTER");break;
		case DRM_IOCTL_ADD_CTX: pos += sprintf(ob +pos, "DRM_IOCTL_ADD_CTX");break;
		case DRM_IOCTL_RM_CTX: pos += sprintf(ob +pos, "DRM_IOCTL_RM_CTX");break;
		case DRM_IOCTL_MOD_CTX: pos += sprintf(ob +pos, "DRM_IOCTL_MOD_CTX");break;
		case DRM_IOCTL_GET_CTX: pos += sprintf(ob +pos, "DRM_IOCTL_GET_CTX");break;
		case DRM_IOCTL_SWITCH_CTX: pos += sprintf(ob +pos, "DRM_IOCTL_SWITCH_CTX");break;
		case DRM_IOCTL_NEW_CTX: pos += sprintf(ob +pos, "DRM_IOCTL_NEW_CTX");break;
		case DRM_IOCTL_RES_CTX: pos += sprintf(ob +pos, "DRM_IOCTL_RES_CTX");break;
		case DRM_IOCTL_ADD_DRAW: pos += sprintf(ob +pos, "DRM_IOCTL_ADD_DRAW");break;
		case DRM_IOCTL_RM_DRAW: pos += sprintf(ob +pos, "DRM_IOCTL_RM_DRAW");break;
		case DRM_IOCTL_DMA: pos += sprintf(ob +pos, "DRM_IOCTL_DMA");break;
		case DRM_IOCTL_LOCK: pos += sprintf(ob +pos, "DRM_IOCTL_LOCK");break;
		case DRM_IOCTL_UNLOCK: pos += sprintf(ob +pos, "DRM_IOCTL_UNLOCK");break;
		case DRM_IOCTL_FINISH: pos += sprintf(ob +pos, "DRM_IOCTL_FINISH");break;
		case DRM_IOCTL_PRIME_HANDLE_TO_FD: pos += sprintf(ob +pos, "DRM_IOCTL_PRIME_HANDLE_TO_FD");break;
		case DRM_IOCTL_PRIME_FD_TO_HANDLE: pos += sprintf(ob +pos, "DRM_IOCTL_PRIME_FD_TO_HANDLE");break;
		case DRM_IOCTL_AGP_ACQUIRE: pos += sprintf(ob +pos, "DRM_IOCTL_AGP_ACQUIRE");break;
		case DRM_IOCTL_AGP_RELEASE: pos += sprintf(ob +pos, "DRM_IOCTL_AGP_RELEASE");break;
		case DRM_IOCTL_AGP_ENABLE: pos += sprintf(ob +pos, "DRM_IOCTL_AGP_ENABLE");break;
		case DRM_IOCTL_AGP_INFO: pos += sprintf(ob +pos, "DRM_IOCTL_AGP_INFO");break;
		case DRM_IOCTL_AGP_ALLOC: pos += sprintf(ob +pos, "DRM_IOCTL_AGP_ALLOC");break;
		case DRM_IOCTL_AGP_FREE: pos += sprintf(ob +pos, "DRM_IOCTL_AGP_FREE");break;
		case DRM_IOCTL_AGP_BIND: pos += sprintf(ob +pos, "DRM_IOCTL_AGP_BIND");break;
		case DRM_IOCTL_AGP_UNBIND: pos += sprintf(ob +pos, "DRM_IOCTL_AGP_UNBIND");break;
		case DRM_IOCTL_SG_ALLOC: pos += sprintf(ob +pos, "DRM_IOCTL_SG_ALLOC");break;
		case DRM_IOCTL_SG_FREE: pos += sprintf(ob +pos, "DRM_IOCTL_SG_FREE");break;
		case DRM_IOCTL_WAIT_VBLANK: pos += sprintf(ob +pos, "DRM_IOCTL_WAIT_VBLANK");break;
		case DRM_IOCTL_CRTC_GET_SEQUENCE: pos += sprintf(ob +pos, "DRM_IOCTL_CRTC_GET_SEQUENCE");break;
		case DRM_IOCTL_CRTC_QUEUE_SEQUENCE: pos += sprintf(ob +pos, "DRM_IOCTL_CRTC_QUEUE_SEQUENCE");break;
		case DRM_IOCTL_UPDATE_DRAW: pos += sprintf(ob +pos, "DRM_IOCTL_UPDATE_DRAW");break;
		case DRM_IOCTL_MODE_GETRESOURCES: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_GETRESOURCES");break;
		case DRM_IOCTL_MODE_GETCRTC: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_GETCRTC");break;
		case DRM_IOCTL_MODE_SETCRTC: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_SETCRTC");break;
		case DRM_IOCTL_MODE_CURSOR: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_CURSOR");break;
		case DRM_IOCTL_MODE_GETGAMMA: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_GETGAMMA");break;
		case DRM_IOCTL_MODE_SETGAMMA: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_SETGAMMA");break;
		case DRM_IOCTL_MODE_GETENCODER: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_GETENCODER");break;
		case DRM_IOCTL_MODE_GETCONNECTOR: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_GETCONNECTOR");break;
		case DRM_IOCTL_MODE_ATTACHMODE: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_ATTACHMODE");break;
		case DRM_IOCTL_MODE_DETACHMODE: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_DETACHMODE");break;
		case DRM_IOCTL_MODE_GETPROPERTY: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_GETPROPERTY");break;
		case DRM_IOCTL_MODE_SETPROPERTY: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_SETPROPERTY");break;
		case DRM_IOCTL_MODE_GETPROPBLOB: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_GETPROPBLOB");break;
		case DRM_IOCTL_MODE_GETFB: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_GETFB");break;
		case DRM_IOCTL_MODE_ADDFB: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_ADDFB");break;
		case DRM_IOCTL_MODE_RMFB: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_RMFB");break;
		case DRM_IOCTL_MODE_PAGE_FLIP: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_PAGE_FLIP");break;
		case DRM_IOCTL_MODE_DIRTYFB: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_DIRTYFB");break;
		case DRM_IOCTL_MODE_CREATE_DUMB: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_CREATE_DUMB");break;
		case DRM_IOCTL_MODE_MAP_DUMB: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_MAP_DUMB");break;
		case DRM_IOCTL_MODE_DESTROY_DUMB: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_DESTROY_DUMB");break;
		case DRM_IOCTL_MODE_GETPLANERESOURCES: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_GETPLANERESOURCES");break;
		case DRM_IOCTL_MODE_GETPLANE: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_GETPLANE");break;
		case DRM_IOCTL_MODE_SETPLANE: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_SETPLANE");break;
		case DRM_IOCTL_MODE_ADDFB2: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_ADDFB2");break;
		case DRM_IOCTL_MODE_OBJ_GETPROPERTIES: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_OBJ_GETPROPERTIES");break;
		case DRM_IOCTL_MODE_OBJ_SETPROPERTY: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_OBJ_SETPROPERTY");break;
		case DRM_IOCTL_MODE_CURSOR2: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_CURSOR2");break;
		case DRM_IOCTL_MODE_ATOMIC: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_ATOMIC");break;
		case DRM_IOCTL_MODE_CREATEPROPBLOB: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_CREATEPROPBLOB");break;
		case DRM_IOCTL_MODE_DESTROYPROPBLOB: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_DESTROYPROPBLOB");break;
		case DRM_IOCTL_SYNCOBJ_CREATE: pos += sprintf(ob +pos, "DRM_IOCTL_SYNCOBJ_CREATE");break;
		case DRM_IOCTL_SYNCOBJ_DESTROY: pos += sprintf(ob +pos, "DRM_IOCTL_SYNCOBJ_DESTROY");break;
		case DRM_IOCTL_SYNCOBJ_HANDLE_TO_FD: pos += sprintf(ob +pos, "DRM_IOCTL_SYNCOBJ_HANDLE_TO_FD");break;
		case DRM_IOCTL_SYNCOBJ_FD_TO_HANDLE: pos += sprintf(ob +pos, "DRM_IOCTL_SYNCOBJ_FD_TO_HANDLE");break;
		case DRM_IOCTL_SYNCOBJ_WAIT: pos += sprintf(ob +pos, "DRM_IOCTL_SYNCOBJ_WAIT");break;
		case DRM_IOCTL_SYNCOBJ_RESET: pos += sprintf(ob +pos, "DRM_IOCTL_SYNCOBJ_RESET");break;
		case DRM_IOCTL_SYNCOBJ_SIGNAL: pos += sprintf(ob +pos, "DRM_IOCTL_SYNCOBJ_SIGNAL");break;
		case DRM_IOCTL_MODE_CREATE_LEASE: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_CREATE_LEASE");break;
		case DRM_IOCTL_MODE_LIST_LESSEES: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_LIST_LESSEES");break;
		case DRM_IOCTL_MODE_GET_LEASE: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_GET_LEASE");break;
		case DRM_IOCTL_MODE_REVOKE_LEASE: pos += sprintf(ob +pos, "DRM_IOCTL_MODE_REVOKE_LEASE");break;

	    } // end switch

		}
	} // end if !Exit

   	else{
		if (!mine) return NOT_HANDLED;
		if (mine) {

			mine = 0;

			uint64_t code = (uint64_t)getSavedRegValue(REG_ARG_1);


		}

	}
	updateOutputBufferPos(pos);
   	return 0;
} // ioctl




int init = 0;
__attribute__((constructor)) void _init(void) {
	
	if (init) return;
	init++;	
	fprintf(stderr,"LOADED dri plugin, hooking ioctl\n");
	gColor = config_color();

	ignoreAllSyscalls();

	int rc= registerSyscallHandler ("ioctl", // char *SyscallName, // must exist or you'll get -1 
	        (void *)dri_ioctl,  // syscall_handler_func Handler,     // Your callback, per above
		0, //              int Bitness,     // 32, 64 or 0 (both)
		0);	//      int Flags);      // as per flags, above


}


