#include "jtraceAPI.h"
#include <stdio.h>

// Sample plugin for JTrace API
// ----------------------------
//
// I made the API very simple but (hopefully) effective - q.v. the H file,
// which I've fully documented.
//
// Basically, you create a dylib, 
//
// Please direct any suggestions for improvements, or additional APIs
// you may want to me via NewAndroidBook.com
// 
//

int my_open  ( int Exit, int Pid)
{


	fprintf(stderr,"----IN MY HANDLER for PID %d on %s!\n", Pid,
		Exit ? "exit" : "entry");
	
	if (!Exit) {
	long arg0 = getRegValue (REG_ARG_0); // int num, 

	// arg0 holds a pointer to the file name

	// If you know the argument is a pointer,
	// you can read the process memory!
	//
	
  	char *myBuf = alloca(512);
	int rc = readProcessMemory (Pid, // int Pid, 
			   arg0, // arch_int Addr, 
			   512, // int Size, 
			   myBuf); // char *MyAddr);

	if (rc < 0) { fprintf(stderr,"Unable to read process memory - err: %d\n", rc);}
	else {
		fprintf(stderr,"FILENAME IS %s..\n", myBuf);
	
		
		// Example - overwrite process memory
		char *x = "/etc/hosts";
		char *y = "/etc/passwd";

		if (y && (strcmp(myBuf, x) == 0))
		{
	
		fprintf(stderr,"REDIRECTING %s to %s!\n", x,y);
		rc = writeProcessMemory (Pid, // int Pid, 
			   arg0, // arch_int Addr, 
			   strlen(y)+1, // int Size, 
			   y); // char *MyAddr);
		}

	}

	}

	return 0;
} 

int my_openat  (int Exit, int Pid)
{


	fprintf(stderr,"----IN MY HANDLER for PID %d on %s!\n", Pid,
		Exit ? "exit" : "entry");
	
	if (!Exit) {
	long arg0 = getRegValue ( REG_ARG_1); // int num, 
	// arg0 holds a pointer to the file name

	// If you know the argument is a pointer,
	// you can read the process memory!
	//
	
  	char *myBuf = alloca(512);
	int rc = readProcessMemory (Pid, // int Pid, 
			   arg0, // arch_int Addr, 
			   512, // int Size, 
			   myBuf); // char *MyAddr);

	if (rc < 0) { fprintf(stderr,"Unable to read process memory - err: %d\n", rc);}
	else {
		fprintf(stderr,"FILENAME IS %s..\n", myBuf);
		
		// Example - overwrite process memory
		char *x = "/etc/hosts";
		char *y = "/vendor/etc/hosts";

		printf("Y IS %s\n", y);
		if (y && (strcmp(myBuf, x) == 0))
		{
	
		fprintf(stderr,"REDIRECTING %s to %s!\n", x,y);
		rc = writeProcessMemory (Pid, // int Pid, 
			   arg0, // arch_int Addr, 
			   strlen(y)+1, // int Size, 
			   y); // char *MyAddr);
		}

	}

	}

	return 0;
} 

int beenHere = 0;

__attribute__((constructor)) void _init(void) {
	
	if (beenHere) return;
	beenHere++;	
	fprintf(stderr,"IN PLUGIN\n");


	int rc= registerSyscallHandler ("open", // char *SyscallName, // must exist or you'll get -1 
	        my_open,  // syscall_handler_func Handler,     // Your callback, per above
		0, //              int Bitness,     // 32, 64 or 0 (both)
		0);	//      int Flags);      // as per flags, above

	// Android uses openat

	 rc= registerSyscallHandler ("openat", // char *SyscallName, // must exist or you'll get -1 
	        my_openat,  // syscall_handler_func Handler,     // Your callback, per above
		0, //              int Bitness,     // 32, 64 or 0 (both)
		0);	//      int Flags);      // as per flags, above

	
	
}


#if 0

[root@localhost jtrace]# adb shell
sailfish:/ $ echo $$
7719

## Then run jtrace in another window, telling it to follow forks and load your plugin:


sailfish:/ # /data/local/tmp/jtrace64 -jdebug --plugin /data/local/tmp/plugin.so -p 7719 # your shell PID goes here
IN PLUGIN
Chaining handler for open as default
Chaining handler for openat as default
Loaded plugin: /data/local/tmp/plugin.so
...
----IN MY HANDLER for PID 7719 on entry!
FILENAME IS /etc/hosts..
Y IS /init.rc
REDIRECTING /etc/hosts to /init.rc!
----IN MY HANDLER for PID 7719 on exit!


# then in the original shell window, try:
sailfish:/ $ cat /etc/hosts
/system/bin/sh: cat: /init.rc: Permission denied

# :-)

# On x86_64 use the x86 plugin
/x86/jtrace.x86 --plugin ./x86/plugin.so /usr/bin/cat /etc/hosts 





#endif

