#include "jtraceAPI.h"
#include <stdio.h>
#include "colors.h"
#include <stdlib.h> // malloc,free
#include <sys/ioctl.h>
#include <string.h>
#include "msm_kgsl.h"


// Sample plugin for JTrace API
// ----------------------------
//
// I made the API very simple but (hopefully) effective - q.v. the H file,
// which I've fully documented.
//
// Basically, you create a dylib, 
//
// Please direct any suggestions for improvements, or additional APIs
// you may want to me via NewAndroidBook.com
// 
//


#if 0
31233(surfaceflinger): ioctl (15 </dev/kgsl-3d0>, 0x40200946 ...);
31233(surfaceflinger): ioctl (15 </dev/kgsl-3d0>, 0xc0200948 ...);
31233(surfaceflinger): ioctl (15 </dev/kgsl-3d0>, 0xc0300947 ...);
31233(surfaceflinger): ioctl (15 </dev/kgsl-3d0>, 0xc040094a ...);
31233(surfaceflinger): ioctl (15 </dev/kgsl-3d0>, 0xc0200933 ...);
#endif




extern int config_color (void);

int gColor ;


	
const char *kgslMemFlagsToText(uint64_t Flags){

	static char returned[1024];

	returned[0] = '\0';
	if (Flags &KGSL_MEMFLAGS_SECURE) strcat (returned, "SECURE,");
	if (Flags & KGSL_MEMFLAGS_GPUREADONLY) strcat (returned,"GPUREADONLY,");
	if (Flags & KGSL_MEMFLAGS_GPUWRITEONLY) strcat(returned,"GPUWRITEONLY,");
	if (Flags & KGSL_MEMFLAGS_FORCE_32BIT) strcat(returned,"FORCE32,");
	if (Flags & KGSL_MEMFLAGS_USE_CPU_MAP) strcat(returned,"USE_CPU_MAP,");
	if (Flags & KGSL_MEMFLAGS_SPARSE_PHYS) strcat(returned,"SPARSE_PHYS,");
	if (Flags & KGSL_MEMFLAGS_SPARSE_VIRT) strcat(returned,"SPARSE_VIRT,");
	if (Flags & KGSL_MEMFLAGS_IOCOHERENT) strcat(returned,"IOCOHERENT,");



	if (returned[0]) { returned[strlen(returned)-1] = '\0';}
	return (returned);

} //

int kgsl_ioctl (int Exit, int Pid)
{


   // @TODO: put this in TLS plugin private
   static int mine = 0;

	char *ob = getOutputBuffer();

	int pos = 0;


   if (!Exit) {

 	int fd = (int) getRegValue(REG_ARG_0);
 	uint64_t code = (uint64_t) getRegValue(REG_ARG_1);

	char *devNode = getFDName(fd);
	if (devNode && strcmp (devNode, "/dev/kgsl-3d0") == 0)
	{
		uint64_t dgAddr;
		mine++;


		pos += sprintf(ob + pos, "%sioctl%s(%d<%s>,", 
			gColor ? BLUE:"", gColor?NORMAL:"",fd, devNode);
		switch (code) {


	case IOCTL_KGSL_DEVICE_GETPROPERTY: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_DEVICE_GETPROPERTY");
		break;
	case IOCTL_KGSL_DEVICE_WAITTIMESTAMP: 
		
		pos += sprintf(ob + pos, "IOCTL_KGSL_DEVICE_WAITTIMESTAMP");
		break;
	case IOCTL_KGSL_DEVICE_WAITTIMESTAMP_CTXTID: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_DEVICE_WAITTIMESTAMP_CTXTID");
		break;
	case IOCTL_KGSL_RINGBUFFER_ISSUEIBCMDS: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_RINGBUFFER_ISSUEIBCMDS");
		break;
	case IOCTL_KGSL_CMDSTREAM_READTIMESTAMP_OLD: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_CMDSTREAM_READTIMESTAMP_OLD");
		break;
	case IOCTL_KGSL_CMDSTREAM_READTIMESTAMP: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_CMDSTREAM_READTIMESTAMP");
		break;
	case IOCTL_KGSL_CMDSTREAM_FREEMEMONTIMESTAMP: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_CMDSTREAM_FREEMEMONTIMESTAMP");
		break;
	case IOCTL_KGSL_CMDSTREAM_FREEMEMONTIMESTAMP_OLD: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_CMDSTREAM_FREEMEMONTIMESTAMP_OLD");
		break;
	case IOCTL_KGSL_DRAWCTXT_CREATE: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_DRAWCTXT_CREATE");
		break;
	case IOCTL_KGSL_DRAWCTXT_DESTROY: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_DRAWCTXT_DESTROY");
		break;
	case IOCTL_KGSL_MAP_USER_MEM: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_MAP_USER_MEM");
		break;
	case IOCTL_KGSL_CMDSTREAM_READTIMESTAMP_CTXTID: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_CMDSTREAM_READTIMESTAMP_CTXTID");
		break;
	case IOCTL_KGSL_CMDSTREAM_FREEMEMONTIMESTAMP_CTXTID: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_CMDSTREAM_FREEMEMONTIMESTAMP_CTXTID");
		break;
	case IOCTL_KGSL_SHAREDMEM_FROM_PMEM: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_SHAREDMEM_FROM_PMEM");
		break;
	case IOCTL_KGSL_SHAREDMEM_FREE: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_SHAREDMEM_FREE");
		break;
	case IOCTL_KGSL_CFF_USER_EVENT: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_CFF_USER_EVENT");
		break;
	case IOCTL_KGSL_DRAWCTXT_BIND_GMEM_SHADOW: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_DRAWCTXT_BIND_GMEM_SHADOW");
		break;
	case IOCTL_KGSL_SHAREDMEM_FROM_VMALLOC: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_SHAREDMEM_FROM_VMALLOC");
		break;
	case IOCTL_KGSL_SHAREDMEM_FLUSH_CACHE: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_SHAREDMEM_FLUSH_CACHE");
		break;
	case IOCTL_KGSL_DRAWCTXT_SET_BIN_BASE_OFFSET: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_DRAWCTXT_SET_BIN_BASE_OFFSET");
		break;
	case IOCTL_KGSL_CMDWINDOW_WRITE: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_CMDWINDOW_WRITE");
		break;
	case IOCTL_KGSL_GPUMEM_ALLOC: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_GPUMEM_ALLOC");
		break;
	case IOCTL_KGSL_CFF_SYNCMEM: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_CFF_SYNCMEM");
		break;
		/*
	case IOCTL_KGSL_TIMESTAMP_EVENT_OLD: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_TIMESTAMP_EVENT_OLD");
		break;
		*/
	case IOCTL_KGSL_SETPROPERTY: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_SETPROPERTY");
		break;
	case IOCTL_KGSL_TIMESTAMP_EVENT: 
		{
		struct kgsl_timestamp_event kte;
	
		 int rc=  readProcessMemory (Pid,
                                getSavedRegValue(REG_ARG_2),
                                sizeof(struct kgsl_timestamp_event),
                                (void*)&kte);

	
		pos += sprintf(ob + pos, "%sIOCTL_KGSL_TIMESTAMP_EVENT%s(Type: %d, %d, context: %d, priv: %ld bytes@%p)",
			gColor? RED: "", gColor? NORMAL:"",kte.type, kte.timestamp, kte.context_id, 
			kte.len, kte.priv);
		break;
		}
	case IOCTL_KGSL_GPUMEM_ALLOC_ID: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_GPUMEM_ALLOC_ID");
		break;
	case IOCTL_KGSL_GPUMEM_FREE_ID: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_GPUMEM_FREE_ID");
		break;
	case IOCTL_KGSL_GPUMEM_GET_INFO:
		pos += sprintf(ob + pos, "IOCTL_KGSL_GPUMEM_GET_INFO");
                break;
	case IOCTL_KGSL_GPUMEM_SYNC_CACHE: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_GPUMEM_SYNC_CACHE");
		break;
	case IOCTL_KGSL_PERFCOUNTER_GET: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_PERFCOUNTER_GET");
		break;
	case IOCTL_KGSL_PERFCOUNTER_PUT: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_PERFCOUNTER_PUT");
		break;
	case IOCTL_KGSL_PERFCOUNTER_QUERY: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_PERFCOUNTER_QUERY");
		break;
	case IOCTL_KGSL_PERFCOUNTER_READ: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_PERFCOUNTER_READ");
		break;
	case IOCTL_KGSL_GPUMEM_SYNC_CACHE_BULK: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_GPUMEM_SYNC_CACHE_BULK");
		break;
	case IOCTL_KGSL_SUBMIT_COMMANDS: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_SUBMIT_COMMANDS");
		break;
	case IOCTL_KGSL_SYNCSOURCE_CREATE: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_SYNCSOURCE_CREATE");
		break;
	case IOCTL_KGSL_SYNCSOURCE_DESTROY: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_SYNCSOURCE_DESTROY");
		break;
	case IOCTL_KGSL_SYNCSOURCE_CREATE_FENCE: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_SYNCSOURCE_CREATE_FENCE");
		break;
	case IOCTL_KGSL_SYNCSOURCE_SIGNAL_FENCE: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_SYNCSOURCE_SIGNAL_FENCE");
		break;
	case IOCTL_KGSL_CFF_SYNC_GPUOBJ: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_CFF_SYNC_GPUOBJ");
		break;
	case IOCTL_KGSL_GPUOBJ_ALLOC:  // egress;
		break;
	case IOCTL_KGSL_GPUOBJ_FREE: 
		{
		struct kgsl_gpuobj_free kgf = {0};
		int rc=  readProcessMemory (Pid,  
				getSavedRegValue(REG_ARG_2), 
				sizeof(struct kgsl_gpuobj_free), 
			(void*)	&kgf);

		pos += sprintf(ob + pos, "%sIOCTL_KGSL_GPUOBJ_FREE%s, { id: %d, flags: 0x%lx, type: %d, len: %d, priv: 0x%lx}",
		gColor?RED:"", gColor?NORMAL:"",
		kgf.id,
		kgf.flags, kgf.type, kgf.len,kgf.priv);
		break;
		}
	case IOCTL_KGSL_GPUOBJ_INFO:  break; // egress

	case IOCTL_KGSL_GPUOBJ_IMPORT: break;//egress

		

	case IOCTL_KGSL_GPUOBJ_SYNC: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_GPUOBJ_SYNC");
		break;
	case IOCTL_KGSL_GPU_COMMAND: 
		{
		  struct kgsl_gpu_command kgc = {0};
		
		int rc=  readProcessMemory (Pid,  
				getSavedRegValue(REG_ARG_2), 
				sizeof(struct kgsl_gpu_command), 
			(void*)	&kgc);


		pos += sprintf(ob + pos, "%sIOCTL_KGSL_GPU_COMMAND%s, {"
		,gColor? RED:"", gColor ? NORMAL:"");
	
		if (kgc.numcmds) {
		pos += sprintf(ob+pos, "%u cmds @0x%lx {",
		kgc.numcmds, kgc.cmdlist);

		struct kgsl_command_object *kco = (struct kgsl_command_object *)
				malloc(sizeof (struct kgsl_command_object) * kgc.numcmds);


		readProcessMemory(Pid, kgc.cmdlist, sizeof (struct kgsl_command_object) * kgc.numcmds, (void*)kco);

		int c = 0;
		for (c = 0; c < kgc.numcmds; c++) {
		pos += sprintf(ob+pos, "%sid: %d, offset : 0x%lx, gpuaddr: 0x%lx, size: 0x%lx, flags: 0x%x ",
		   c>0?", " :"",
		   kco[c].id, kco[c].offset, kco[c].gpuaddr, kco[c].size, kco[c].flags);

		} // end for

		free(kco);

	
			}
		if (kgc.numobjs) {
		pos += sprintf(ob + pos, ", %d objs @0x%lx",
		kgc.numobjs, kgc.objlist);
		}

		if (kgc.numsyncs) {
			pos+= sprintf(ob+pos, ", %d syncs @0x%lx",
		kgc.numsyncs, kgc.synclist);
			}

		ob[pos++] = '}';
		ob[pos] = '\0';
		}
		break;
	case IOCTL_KGSL_PREEMPTIONCOUNTER_QUERY: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_PREEMPTIONCOUNTER_QUERY");
		break;
	case IOCTL_KGSL_GPUOBJ_SET_INFO: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_GPUOBJ_SET_INFO");
		break;
	case IOCTL_KGSL_SPARSE_PHYS_ALLOC: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_SPARSE_PHYS_ALLOC");
		break;
	case IOCTL_KGSL_SPARSE_PHYS_FREE: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_SPARSE_PHYS_FREE");
		break;
	case IOCTL_KGSL_SPARSE_VIRT_ALLOC: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_SPARSE_VIRT_ALLOC");
		break;
	case IOCTL_KGSL_SPARSE_VIRT_FREE: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_SPARSE_VIRT_FREE");
		break;
	case IOCTL_KGSL_SPARSE_BIND: 
		pos += sprintf(ob + pos, "IOCTL_KGSL_SPARSE_BIND");
		break;
	case IOCTL_KGSL_GPU_SPARSE_COMMAND: 
		sprintf(ob + pos, "IOCTL_KGSL_GPU_SPARSE_COMMAND");
		break;
		default: pos += sprintf(ob + pos, "Code 0x%lx (unknown - tell J!)", code);
		} // switch code
	}

		
	else {	// ! mine..

			return 2;

	    } // end switch

	} // end if !Exit

   	else{
		if (mine) {

			mine = 0;

			uint64_t code = (uint64_t)getSavedRegValue(REG_ARG_1);

			switch (code) {
	
			case IOCTL_KGSL_GPUOBJ_ALLOC:
			{
				struct kgsl_gpuobj_alloc kga;
				int rc=  readProcessMemory (Pid,  
				getSavedRegValue(REG_ARG_2), 
				sizeof(struct kgsl_gpuobj_alloc), 
				(void *)&kga);


		pos += sprintf(ob + pos, "%sIOCTL_KGSL_GPUOBJ_ALLOC%s, {id: %d, Size: %ld, VA: 0x%lx, MMap: 0x%lx }",
			gColor?RED:"", gColor?NORMAL:"",
	kga.id, kga.size, kga.va_len, kga.mmapsize);
				break;


			}
			case IOCTL_KGSL_GPUOBJ_INFO: 
			{
				struct kgsl_gpuobj_info kgi;
				int rc=  readProcessMemory (Pid,  
				getSavedRegValue(REG_ARG_2), 
				sizeof(struct kgsl_gpuobj_info), 
				(void *)&kgi);

		
		pos += sprintf(ob + pos, "%sIOCTL_KGSL_GPUOBJ_INFO%s, {id: %d, %ld@0x%lx, VA: %ld@0X%lx}", 

			gColor?RED:"", gColor?NORMAL:"",
			kgi.id,
			kgi.size, kgi.gpuaddr, kgi.va_len, kgi.va_addr);

		break;
		}
		case IOCTL_KGSL_GPUOBJ_IMPORT: 
		{
		// Can optimize and do kgi only on exit
		struct kgsl_gpuobj_import kgi;
		int rc=  readProcessMemory (Pid,  
				getSavedRegValue(REG_ARG_2), 
				sizeof(struct kgsl_gpuobj_import), 
			(void*)	&kgi);

		pos += sprintf(ob + pos, "%sIOCTL_KGSL_GPUOBJ_IMPORT%s (0x%x), { type: %d, flags: %s priv: %ld@0x%lx, %sid: %d%s}",
			gColor?RED:"", gColor ?NORMAL:"", code,
			kgi.type, kgslMemFlagsToText(kgi.flags), kgi.priv_len, kgi.priv, gColor? BLUE:"",
				kgi.id, gColor?NORMAL:"");

	

			}
		default: return NOT_HANDLED;
		} // end switch
 		int rc = (int) getRegValue(REG_ARG_0);

		}


	}
	updateOutputBufferPos(pos);
   	return 0;
} // ioctl




int init = 0;
__attribute__((constructor)) void _init(void) {
	
	if (init) return;
	init++;	
	fprintf(stderr,"LOADED kgsl plugin, hooking ioctl\n");
	gColor = config_color();

	//if (getenv("KGSL") != NULL) 
	ignoreAllSyscalls();

	int rc= registerSyscallHandler ("ioctl", // char *SyscallName, // must exist or you'll get -1 
	        (void *)kgsl_ioctl,  // syscall_handler_func Handler,     // Your callback, per above
		0, //              int Bitness,     // 32, 64 or 0 (both)
		0);	//      int Flags);      // as per flags, above


}


