#include "jtraceAPI.h"
#include <stdio.h>
#include "../colors.h"
#include "mcLoadFormat.h"
#include "mc_user.h"
#include "mc_admin.h"


// Sample plugin for JTrace API - for mcDriverDaemon
// ----------------------------
//
// I made the API very simple but (hopefully) effective - q.v. the H file,
// which I've fully documented.
//
// Basically, you create a dylib, 
//
// Please direct any suggestions for improvements, or additional APIs
// you may want to me via NewAndroidBook.com
// 
//



extern int config_color (void);

int gColor ;

int mcDriverDaemon_ioctl (regs_t *Regs, int Exit, int Pid)
{

   if (!Exit) {
 	int fd = (int) getRegValue(Regs,REG_ARG_0,0);
 	int code = (int) getRegValue(Regs,REG_ARG_1,0);

	char *devNode = getFDName(fd);

	printf("ioctl (%d<%s>,", fd, devNode);

	if (devNode && strcmp (devNode, "/dev/mobicore") == 0)
	{
		switch (code) {

		case MC_ADMIN_IO_GET_DRIVER_REQUEST:
			printf ("GET_DRIVER_REQUEST");
			break;
		case MC_ADMIN_IO_GET_INFO:
			printf ("GET_INFO");
			break;
		case MC_ADMIN_IO_LOAD_DRIVER:
			printf ("LOAD_DRIVER");
			break;
		case MC_ADMIN_IO_LOAD_TOKEN:
			printf ("LOAD_TOKEN");
			break;
		case MC_ADMIN_IO_LOAD_CHECK:
			printf ("LOAD_CHECK");
			break;
		default: printf("Code 0x%x (unknown - tell J!)", code);
		} // switch code
	}

	else {

		switch (code) {


	case MC_IO_OPEN_SESSION:
		printf ("MC_IO_OPEN_SESSION");
		break;

		default:
		printf("Code: 0x%x", code);

		} // end switch

	} // end dev/mobicore
	} // end if !Exit

} // ioctl

int mcDriverDaemon_write (regs_t *Regs, int Exit, int Pid)
{

	static int saved_fd;
	int readRC = 0;
	if (!Exit)
	{

		long arg0 = getRegValue(Regs,REG_ARG_0,0);
 		saved_fd = (int) getRegValue(Regs,REG_ARG_0,0);

		if (arg0  > 255) { printf("write %ld?!\n", arg0);}
		if (gColor) printf(BOLD);
		printf("write (");
		if (gColor) printf(NORMAL);
		printf ("%d", arg0);
		printf (",");

	unsigned long addr =  getRegValue(Regs,REG_ARG_1,0);


	readRC = getRegValue (Regs,REG_ARG_RETVAL,0);

 	char *fdName = getFDName (saved_fd);

	int format = 0;

        if (fdName && strcmp(fdName, "/dev/mobicore") ==0)
	{

		// I use alloca because it's simpler and faster
		// caveat: if readRC is too big, it would explode
		// the stack. Either check readRC or use malloc..
		// (but mcDriverDaemon never reads much..)
		//
		char *buf = alloca(readRC);
		int rc = readProcessMemory(Pid,
			addr,
			readRC,
			buf);

		if (rc <0) {

		printf("<ERROR>");
		
		}
		else {

			// If buffer begins with MCLF:
			
		if (memcmp(buf,MC_SERVICE_HEADER_MAGIC_STR, strlen(MC_SERVICE_HEADER_MAGIC_STR)) == 0)
		{

			mclfHeaderV2_ptr mclfhv2 = (mclfHeaderV2_ptr) buf;

			printf("MCLF v%x trustlet: loaded into %p-%p (text), %p-%p (data)\n",
			mclfhv2->intro.version,
			mclfhv2->text.start, 
				mclfhv2->text.start + mclfhv2->text.len,
				mclfhv2->data.start, 
				mclfhv2->data.start + mclfhv2->data.len);
		


			}
		}



	} 


	} // end if
	else {

	}
	if (gColor) { printf(NORMAL); }
	printf (")= %d", readRC);

	return 0;
} // mcDriverDaemon_write



int init = 0;
__attribute__((constructor)) void _init(void) {
	
	if (init) return;
	init++;	
	fprintf(stderr,"LOADED mcDriverDaemon PLUGIN, hooking write\n");
	gColor = config_color();

	int rc= registerSyscallHandler ("write", // char *SyscallName, // must exist or you'll get -1 
	        mcDriverDaemon_write,  // syscall_handler_func Handler,     // Your callback, per above
		0, //              int Bitness,     // 32, 64 or 0 (both)
		0);	//      int Flags);      // as per flags, above

	rc= registerSyscallHandler ("ioctl", // char *SyscallName, // must exist or you'll get -1 
	        mcDriverDaemon_ioctl,  // syscall_handler_func Handler,     // Your callback, per above
		0, //              int Bitness,     // 32, 64 or 0 (both)
		0);	//      int Flags);      // as per flags, above


}


#if 0

[root@localhost jtrace]# adb shell
sailfish:/ $ echo $$
7719

## Then run jtrace in another window, telling it to follow forks and load your plugin:


sailfish:/ # /data/local/tmp/jtrace64 -jdebug --plugin /data/local/tmp/plugin.so -p 7719 # your shell PID goes here
IN PLUGIN
Chaining handler for open as default
Chaining handler for openat as default
Loaded plugin: /data/local/tmp/plugin.so
...
----IN MY HANDLER for PID 7719 on entry!
FILENAME IS /etc/hosts..
Y IS /init.rc
REDIRECTING /etc/hosts to /init.rc!
----IN MY HANDLER for PID 7719 on exit!


# then in the original shell window, try:
sailfish:/ $ cat /etc/hosts
/system/bin/sh: cat: /init.rc: Permission denied

# :-)

# On x86_64 use the x86 plugin
/x86/jtrace.x86 --plugin ./x86/plugin.so /usr/bin/cat /etc/hosts 





#endif
