#include "jtraceAPI.h"  // For linking back to jtrace
#include <stdio.h> /// sprintf
#include "../colors.h" // I dig color 
#include <sys/ioctl.h>
#include "qseecom.h" // where ioctl codes are 
#include <string.h> // strcmp, strstr..


// Sample plugin for JTrace API
// ----------------------------
//
// I made the API very simple but (hopefully) effective - q.v. the H file,
// which I've fully documented.
//
//
// Please direct any suggestions for improvements, or additional APIs
// you may want to me via NewAndroidBook.com
// 
//



extern int config_color (void);

int gColor ;

int qseecomd_ioctl (int Exit, int Pid)
{


   static int mine = 0;

	char *ob = getOutputBuffer();

	int pos = 0;


   if (!Exit) {

 	int fd = (int) getRegValue(REG_ARG_0);
 	uint64_t code =  getRegValue(REG_ARG_1);

	char *devNode = getFDName(fd);
	if (devNode && strcmp (devNode, "/dev/qseecom") == 0)
	{
		uint64_t dgAddr;
		mine++;


		pos += sprintf(ob + pos, "---->ioctl (%d<%s>,", fd, devNode);



		switch (code) {


		case  QSEECOM_IOCTL_REGISTER_LISTENER_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_REGISTER_LISTENER_REQ"); break; 

		case  QSEECOM_IOCTL_UNREGISTER_LISTENER_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_UNREGISTER_LISTENER_REQ"); break; 

		case  QSEECOM_IOCTL_SEND_CMD_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_SEND_CMD_REQ"); break; 

		case  QSEECOM_IOCTL_SEND_MODFD_CMD_REQ: 

		{
			pos+= sprintf(ob+pos, "QSEECOM_IOCTL_SEND_MODFD_CMD_REQ"); 
#if 0
 The argument is :
struct qseecom_send_modfd_cmd_req {
        void *cmd_req_buf; /* in */
        unsigned int cmd_req_len; /* in */
        void *resp_buf; /* in/out */
        unsigned int resp_len; /* in/out */
        struct qseecom_ion_fd_info ifd_data[MAX_ION_FD];
};


#endif 
			struct qseecom_send_modfd_cmd_req arg;
			uint64_t argVal = getRegValue(REG_ARG_2); // the value -> address in remote.


			int  rc = readProcessMemory (Pid, argVal, // arch_int Addr, 
				sizeof(struct qseecom_send_modfd_cmd_req), // int Size, 
				&arg); // char *MyAddr);

			if (rc >0 ) {

			pos += sprintf(ob+pos,"{ buf: %p of %d bytes, resp buf %p of %d bytes}",
					arg.cmd_req_buf, arg.cmd_req_len,
					arg.resp_buf, arg.resp_len);

			}





		}
			break; 

		case  QSEECOM_IOCTL_RECEIVE_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_RECEIVE_REQ"); break; 

		case  QSEECOM_IOCTL_SEND_RESP_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_SEND_RESP_REQ"); break; 

		case  QSEECOM_IOCTL_LOAD_APP_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_LOAD_APP_REQ"); break; 

		case  QSEECOM_IOCTL_SET_MEM_PARAM_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_SET_MEM_PARAM_REQ"); break; 

		case  QSEECOM_IOCTL_UNLOAD_APP_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_UNLOAD_APP_REQ"); break; 

		case  QSEECOM_IOCTL_GET_QSEOS_VERSION_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_GET_QSEOS_VERSION_REQ"); break; 

		case  QSEECOM_IOCTL_PERF_ENABLE_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_PERF_ENABLE_REQ"); break; 

		case  QSEECOM_IOCTL_PERF_DISABLE_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_PERF_DISABLE_REQ"); break; 

		case  QSEECOM_IOCTL_LOAD_EXTERNAL_ELF_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_LOAD_EXTERNAL_ELF_REQ"); break; 

		case  QSEECOM_IOCTL_UNLOAD_EXTERNAL_ELF_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_UNLOAD_EXTERNAL_ELF_REQ"); break; 

		case  QSEECOM_IOCTL_APP_LOADED_QUERY_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_APP_LOADED_QUERY_REQ"); break; 

		case  QSEECOM_IOCTL_SEND_CMD_SERVICE_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_SEND_CMD_SERVICE_REQ"); break; 

		case  QSEECOM_IOCTL_CREATE_KEY_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_CREATE_KEY_REQ"); break; 

		case  QSEECOM_IOCTL_WIPE_KEY_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_WIPE_KEY_REQ"); break; 

		case  QSEECOM_IOCTL_SAVE_PARTITION_HASH_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_SAVE_PARTITION_HASH_REQ"); break; 

		case  QSEECOM_IOCTL_IS_ES_ACTIVATED_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_IS_ES_ACTIVATED_REQ"); break; 

		case  QSEECOM_IOCTL_SEND_MODFD_RESP: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_SEND_MODFD_RESP"); break; 

		case  QSEECOM_IOCTL_SET_BUS_SCALING_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_SET_BUS_SCALING_REQ"); break; 

		case  QSEECOM_IOCTL_UPDATE_KEY_USER_INFO_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_UPDATE_KEY_USER_INFO_REQ"); break; 

		case  QSEECOM_QTEEC_IOCTL_OPEN_SESSION_REQ: pos+= sprintf(ob+pos, "QSEECOM_QTEEC_IOCTL_OPEN_SESSION_REQ"); break; 

		case  QSEECOM_QTEEC_IOCTL_CLOSE_SESSION_REQ: pos+= sprintf(ob+pos, "QSEECOM_QTEEC_IOCTL_CLOSE_SESSION_REQ"); break; 

		case  QSEECOM_QTEEC_IOCTL_INVOKE_MODFD_CMD_REQ: pos+= sprintf(ob+pos, "QSEECOM_QTEEC_IOCTL_INVOKE_MODFD_CMD_REQ"); break; 

		case  QSEECOM_QTEEC_IOCTL_REQUEST_CANCELLATION_REQ: pos+= sprintf(ob+pos, "QSEECOM_QTEEC_IOCTL_REQUEST_CANCELLATION_REQ"); break; 

		case  QSEECOM_IOCTL_MDTP_CIPHER_DIP_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_MDTP_CIPHER_DIP_REQ"); break; 

		case  QSEECOM_IOCTL_SEND_MODFD_CMD_64_REQ: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_SEND_MODFD_CMD_64_REQ"); break; 

		case  QSEECOM_IOCTL_SEND_MODFD_RESP_64: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_SEND_MODFD_RESP_64"); break; 

		case  QSEECOM_IOCTL_GET_CE_PIPE_INFO: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_GET_CE_PIPE_INFO"); break; 

		case  QSEECOM_IOCTL_FREE_CE_PIPE_INFO: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_FREE_CE_PIPE_INFO"); break; 

		case  QSEECOM_IOCTL_QUERY_CE_PIPE_INFO: pos+= sprintf(ob+pos, "QSEECOM_IOCTL_QUERY_CE_PIPE_INFO"); break; 

		case  QSEECOM_IOCTL_SET_ICE_INFO  : pos+= sprintf(ob+pos, "QSEECOM_IOCTL_SET_ICE_INFO"); break; 

		case  QSEECOM_IOCTL_FBE_CLEAR_KEY : pos +=sprintf(ob+pos, "QSEECOM_IOCTL_FBE_CLEAR_KEY"); break; 


#if 0
					//@@TODO: could be too big!
					char *localBuf = alloca(localDG.len);
					if (localBuf) {
						rc=  readProcessMemory (Pid,  localDG.buf, localDG.len, localBuf);
						pos +=  hexDumpToBuffer (ob+pos,0 , localBuf, localDG.len, localDG.buf, 1);


					}
					else { printf("Can't allocate %d bytes!\n", localDG.len); }


				} // localDG.len
				}

				else {
				pos += sprintf(ob+pos, "CITADEL_IOC_TPM_DATAGRAM - NULL");

				}

#endif
		default: pos += sprintf(ob + pos, "Code 0x%x (unknown - tell J!)", code);
		} // switch code
	}

		
	else {	// ! mine..

			return 2;

	    } // end switch

	} // end if !Exit

   	else{
		if (mine) {

				mine = 0;
 			int rc = (int) getRegValue(REG_ARG_0);

		}


	}
	updateOutputBufferPos(pos);
   	return 0;
} // ioctl




int init = 0; // /system/bin/linker calls us twice (not my fault)

__attribute__((constructor)) void _init(void) {
	
	if (init) return;
	init++;	
	fprintf(stderr,"LOADED qseecomd plugin, hooking ioctl\n");
	gColor = config_color();

	//ignoreAllSyscalls(); // automatically masks all syscalls from jtrace


	int rc= registerSyscallHandler ("ioctl", // char *SyscallName, // must exist or you'll get -1 
	        qseecomd_ioctl,  // syscall_handler_func Handler,     // Your callback, per above
		0, //              int Bitness,     // 32, 64 or 0 (both)
		0);	//      int Flags);      // as per flags, above


}


