#include "jtraceAPI.h"
#include <stdio.h>
#include "../colors.h"
#include <sys/ioctl.h>
#include <string.h>
#include "adsprpc_shared.h"

// Sample plugin for JTrace API - for QCOM cdsprpc
// ----------------------------
//
// I made the API very simple but (hopefully) effective - q.v. the H file,
// which I've fully documented.
//
// Basically, you create a dylib, 
//
// Please direct any suggestions for improvements, or additional APIs
// you may want to me via NewAndroidBook.com
// 
//



extern int config_color (void);

int gColor ;

#undef DEVICE_NAME

#define DEVICE_NAME	"/dev/adsprpc-smd" // or /dev/adsprpc-smd-secure

extern int config_color (void);

int cdsprpc_ioctl ( int Exit, int Pid)
{


   static int mine = 0;

   if (!Exit) {

 	int fd = (int) getRegValue(0);
 	uint32_t code = (uint32_t) getRegValue(1);
 	uint64_t ioctl_arg_addr= (uint64_t) getRegValue(REG_ARG_2); // @TODO uint32_t for 32-bit too


	char *devNode = getFDName(fd);


	if (devNode && strstr (devNode, DEVICE_NAME))
	{
		uint64_t dgAddr;
		mine++;

		printf("---->ioctl (%d<%s>, %s ", fd, devNode,
				config_color() ? RED :"");
		switch (code) {


			case FASTRPC_IOCTL_INVOKE: //_IOWR('R', 1, struct fastrpc_ioctl_invoke)
					{
					struct fastrpc_ioctl_invoke 	 fii = {};
					int rc = readProcessMemory(Pid,
						ioctl_arg_addr,
						sizeof(struct fastrpc_ioctl_invoke),
						&fii);
					printf("RC: %d\n", rc); 
					
					
				// Want to read and dump remote scalar length:

				int len = REMOTE_SCALARS_LENGTH(fii.sc) * sizeof(remote_arg64_t);

				int outhandles =  REMOTE_SCALARS_OUTHANDLES(fii.sc);
				int inhandles =  REMOTE_SCALARS_INHANDLES(fii.sc);
				int outbufs = REMOTE_SCALARS_OUTBUFS(fii.sc);
				int inbufs = REMOTE_SCALARS_INBUFS(fii.sc);
				int meth = ( fii.sc >> 24) & 0x1f;

					printf ("FASTRPC_IOCTL_INVOKE on handle 0x%x, Method: %d IH: %d  OH: %d, IB: %d OB: %d Len %d, PRA: %p\n", fii.handle, meth, inhandles, outhandles, inbufs, outbufs, REMOTE_SCALARS_LENGTH(fii.sc),	fii.pra);

				

				 struct rs {
					 uint64_t addr;
					 uint64_t len;

				 } *remoteScalars =
				 	alloca (len);

				 rc = readProcessMemory(Pid,
                                                fii.pra,
                                                len,
                                                remoteScalars);

				 int i = 0;
				 for (i = 0; i < len / sizeof(struct rs); i++) {

					printf("\t%d: %p - %d\n", remoteScalars[i].addr,
								remoteScalars[i].len);
				 }
				 //hexDump(remoteScalars, len, fii.pra,0);

				}
				break;
			case FASTRPC_IOCTL_MMAP: //_IOWR('R', 2, struct fastrpc_ioctl_mmap)
				printf ("FASTRPC_IOCTL_MMAP");
				break;
			case FASTRPC_IOCTL_MUNMAP: //_IOWR('R', 3, struct fastrpc_ioctl_munmap)
				printf ("FASTRPC_IOCTL_MUNMAP");
				break;
			case FASTRPC_IOCTL_MMAP_64: //_IOWR('R', 14, struct fastrpc_ioctl_mmap_64)
				printf ("FASTRPC_IOCTL_MMAP_64");
				break;
			case FASTRPC_IOCTL_MUNMAP_64: //_IOWR('R', 15, struct fastrpc_ioctl_munmap_64)
				printf ("FASTRPC_IOCTL_MUNMAP_64");
				break;
			case FASTRPC_IOCTL_INVOKE_FD: //_IOWR('R', 4, struct fastrpc_ioctl_invoke_fd)
				printf ("FASTRPC_IOCTL_INVOKE_FD");
				break;
			case FASTRPC_IOCTL_SETMODE: //_IOWR('R', 5, uint32_t)
				printf ("FASTRPC_IOCTL_SETMODE");
				break;
			case FASTRPC_IOCTL_INIT: //_IOWR('R', 6, struct fastrpc_ioctl_init)
				printf ("FASTRPC_IOCTL_INIT");
				break;
			case FASTRPC_IOCTL_INVOKE_ATTRS: //_IOWR('R', 7, struct fastrpc_ioctl_invoke_attrs)
				printf ("FASTRPC_IOCTL_INVOKE_ATTRS");
				break;
			case FASTRPC_IOCTL_GETINFO: //_IOWR('R', 8, uint32_t)
				printf ("FASTRPC_IOCTL_GETINFO");
				break;
			case FASTRPC_IOCTL_GETPERF: //_IOWR('R', 9, struct fastrpc_ioctl_perf)
				printf ("FASTRPC_IOCTL_GETPERF");
				break;
			case FASTRPC_IOCTL_INIT_ATTRS: //_IOWR('R', 10, struct fastrpc_ioctl_init_attrs)
				printf ("FASTRPC_IOCTL_INIT_ATTRS");
				break;
			case FASTRPC_IOCTL_INVOKE_CRC: //_IOWR('R', 11, struct fastrpc_ioctl_invoke_crc)
				printf ("FASTRPC_IOCTL_INVOKE_CRC");
				break;
			case FASTRPC_IOCTL_CONTROL: //_IOWR('R', 12, struct fastrpc_ioctl_control)
				printf ("FASTRPC_IOCTL_CONTROL");
				break;
			case FASTRPC_IOCTL_MUNMAP_FD: //_IOWR('R', 13, struct fastrpc_ioctl_munmap_fd)
				printf ("FASTRPC_IOCTL_MUNMAP_FD");
				break;
			case FASTRPC_IOCTL_GET_DSP_INFO: //_IOWR('R', 16, struct fastrpc_ioctl_dsp_capabilities)
				printf ("FASTRPC_IOCTL_GET_DSP_INFO");
				break;


			default: printf("Code 0x%lx (unknown - tell J)!)", code);

		} // switch code
		printf("%s", config_color() ? NORMAL:"");
	}

		
	else {

			return 2;

	    } // end switch

	} // end if !Exit

   	else{
		if (mine) {

				mine = 0;
 			int rc = (int) getRegValue(REG_ARG_0);
			printf("RC:%d\n", rc);
			printf("\n");

		}


	}
   	return 0;
} // ioctl




int init = 0;
__attribute__((constructor)) void _init(void) {
	
	if (init) return; // prevent double loading
	init++;	
	fprintf(stderr,"LOADED cdsprpc plugin, hooking ioctl\n");
	gColor = config_color();


	int rc= registerSyscallHandler ("ioctl", // char *SyscallName, // must exist or you'll get -1 
	        cdsprpc_ioctl,  // syscall_handler_func Handler,     // Your callback, per above
		0, //              int Bitness,     // 32, 64 or 0 (both)
		0);	//      int Flags);      // as per flags, above


}


#if 0

[root@localhost jtrace]# adb shell
sailfish:/ $ echo $$
7719

## Then run jtrace in another window, telling it to follow forks and load your plugin:


sailfish:/ # /data/local/tmp/jtrace64 -jdebug --plugin /data/local/tmp/plugin.so -p 7719 # your shell PID goes here
IN PLUGIN
Chaining handler for open as default
Chaining handler for openat as default
Loaded plugin: /data/local/tmp/plugin.so
...
----IN MY HANDLER for PID 7719 on entry!
FILENAME IS /etc/hosts..
Y IS /init.rc
REDIRECTING /etc/hosts to /init.rc!
----IN MY HANDLER for PID 7719 on exit!


# then in the original shell window, try:
sailfish:/ $ cat /etc/hosts
/system/bin/sh: cat: /init.rc: Permission denied

# :-)

# On x86_64 use the x86 plugin
/x86/jtrace.x86 --plugin ./x86/plugin.so /usr/bin/cat /etc/hosts 





#endif
