#include "jtraceAPI.h"
#include <stdio.h>

// Sample plugin for JTrace API
// ----------------------------
//
// I made the API very simple but (hopefully) effective - q.v. the H file,
// which I've fully documented.
//
// Basically, you create a dylib, 
//
// Please direct any suggestions for improvements, or additional APIs
// you may want to me via NewAndroidBook.com
// 
//

int my_handler  (regs_t *Regs, int Exit, int Pid)
{

	static int is32 = -1;
	if (is32 <0) is32 = get_is32();

	fprintf(stderr,"IN MY HANDLER for PID %d on %s!\n", Pid,
		Exit ? "exit" : "entry");
	
	if (!Exit) {
	long arg0 = getRegValue (Regs, 
				REG_ARG_0, // int num, 
				is32); //
	long arg1 = getRegValue (Regs, 
				REG_ARG_1, // int num, 
				is32); //
	long arg2 = getRegValue (Regs, 
				REG_ARG_2, // int num, 
				is32); //
	printf("1st argument: 0x%x - %s\n", arg0, getFDName(arg0));
	printf("2nd argument: 0x%x\n", arg1);
	printf("3rd argument: 0x%x\n", arg2);

	// If you know the argument is a pointer,
	// you can read the process memory!
	//
	
  	char *myBuf = alloca(arg2);
	int rc = readProcessMemory (Pid, // int Pid, 
			   arg1, // arch_int Addr, 
			   arg2, // int Size, 
			   myBuf); // char *MyAddr);

	if (rc < 0) { fprintf(stderr,"Unable to read process memory - err: %d\n", rc);}
	else {
	
		myBuf[arg2] = '\0';
		printf("Buffer: %s\n", myBuf);
		
		// Example - overwrite process memory
		//
		memset(myBuf, 'J', arg2);
		rc = writeProcessMemory (Pid, // int Pid, 
			   arg1, // arch_int Addr, 
			   arg2, // int Size, 
			   myBuf); // char *MyAddr);

	}

	}
} 

__attribute__((constructor)) void _init(void) {
	
	fprintf(stderr,"IN PLUGIN\n");
	int rc= registerSyscallHandler ("write", // char *SyscallName, // must exist or you'll get -1 
	        my_handler,  // syscall_handler_func Handler,     // Your callback, per above
		0, //              int Bitness,     // 32, 64 or 0 (both)
		0);	//      int Flags);      // as per flags, above

	
}


#if 0

 This is what it would look like, hooking write(2) in InputReader thread

130|sailfish:/ # /data/local/tmp/jtrace64 --thread InputReader --plugin /data/local/tmp/plugin.so  
IN PLUGIN
> Tracing PID 1371 (InputReader, 64-bit) 
> Continuing..
IN MY HANDLER for PID 1371 on entry!
1st argument: 0x3c
2nd argument: 0x21bd8d95
3rd argument: 0x9
Buffer: KeyEvents
IN MY HANDLER for PID 1371 on exit!

#endif

