#include "jtraceAPI.h"
#include <stdio.h>

#include "../colors.h"
#include <string.h>


static int got_color = 0;

void dump_setprop_request(char *buffer, int size)
{

	static int insetpropv2 = 0;

	struct setprop_request {
		int	req;
		char prop[32];
		char val[32];
	} *propreq = (struct setprop_request *) buffer;


	if (!insetpropv2 && propreq->req == 0x20001) {
		printf("%s{ setprop v2 request marker }%s",
			got_color ? BLUE : "",
			got_color ? NORMAL : "");

		insetpropv2++; return ;}
	
	// setprop v1
	if (!insetpropv2) {
		printf("%s{ setprop request for %s = %s }%s", 
			 got_color ? BLUE : "",
			  propreq->prop, propreq->val,
			  got_color ? NORMAL :"");
			return;
		}
	switch (insetpropv2) {
		case 1: // our second time - this is the length of var
		  printf("%s{setprop request - property len: %d }%s",
			 got_color ? BLUE : "",
			propreq->req,
			got_color ? NORMAL :"");
			break;
		case 2: // third time - this is the var
		  printf("%s{setprop request - property: %s }%s",
			 got_color ? BLUE : "",
			 (char *) propreq,
			  got_color ? NORMAL : "") ;
			break;
		case 3:
		  printf("%s{setprop request - value len: %d }%s",
			 got_color ? BLUE : "", 
			propreq->req,
			 got_color ? NORMAL:"");
			break;
		case 4:
		  printf("%s{setprop request - value: %s }%s",
			 got_color ? BLUE : "",
			(char *) propreq,
			 got_color ?NORMAL : "");
			break;
		case 5: printf("%s{end setprop request (0)}%s",
			 got_color ? BLUE : "",
			 got_color ? NORMAL : ""); break;
		}

	insetpropv2++;
	if (insetpropv2 == 6) insetpropv2 = 0;

}

int my_recvfrom  (regs_t *Regs, int Exiting, int Pid)
{

	int is32 = get_is32();
	// If the fd is recognized to be the socket property service, show which
	//  property is set.
	// else go to default
	static int saved_r0 = 0;
	if (!Exiting)  { saved_r0 = getRegValue(Regs,0,is32);
			return  0; }
	
	

	char *fdn = getFDName(saved_r0);

#define PROPERTY_SERVICE_SOCKET_NAME "/dev/socket/property_service"

	if (fdn && strstr(fdn, PROPERTY_SERVICE_SOCKET_NAME))
	{
		if (Exiting) {
	//	if (jtrace_config.color) printf(BOLD);
			printf("recvfrom (");
		//if (jtrace_config.color) printf(NORMAL);
		printf ("%d, ", saved_r0);
		char *reqbuf = alloca(1024); // safe

		readProcessMemory(Pid, 
				getRegValue(Regs, REG_ARG_1, is32),
				getRegValue(Regs, REG_ARG_2, is32),
				reqbuf);

		dump_setprop_request(reqbuf, getRegValue (Regs,2,is32));
			int rc = getRegValue(Regs,0,is32);

			printf ("...) = %d ", rc);
			if (rc < 0) printf ("%s", strerror(rc));
	//		printf("\n");
			return 1;
	}
	else {
			return 0;
		}
	}
	return 0;
} ;

static int c = 0;

__attribute__((constructor)) void _init(void) {
	
	if (c == 0) {
	fprintf(stderr,"IN PLUGIN Constructor\n");
	c++;
	
	
	got_color = config_color();


	int rc= registerSyscallHandler ("recvfrom", // char *SyscallName, // must exist or you'll get -1 
	        my_recvfrom,  // syscall_handler_func Handler,     // Your callback, per above
		0, //              int Bitness,     // 32, 64 or 0 (both)
		0);	//      int Flags);      // as per flags, above
	}

}
