#include "jtraceAPI.h"
#include <stdio.h>
#include "colors.h"
#include <sys/ioctl.h>
#include <string.h>
#include "qcedev.h"
#include "smcinvoke.h"


// Sample plugin for JTrace API
// ----------------------------
//
// I made the API very simple but (hopefully) effective - q.v. the H file,
// which I've fully documented.
//
// Basically, you create a dylib, 
//
// Please direct any suggestions for improvements, or additional APIs
// you may want to me via NewAndroidBook.com
// 
//



extern int config_color (void);

int gColor ;

int smcinvoke_ioctl (int Exit, int Pid)
{


   static int mine = 0;

	char *ob = getOutputBuffer();

	int pos = 0;


   if (!Exit) {

 	int fd = (int) getRegValue(REG_ARG_0);
 	int64_t code = (int64_t) getRegValue(REG_ARG_1);

	char *devNode = getFDName(fd);
	if (devNode && strstr (devNode, "smcinvoke"))
	{
		uint64_t argAddr;
		mine++;


		pos += sprintf(ob + pos, "ioctl (%d<%s>,", fd, devNode);
		switch (code) {

			case SMCINVOKE_IOCTL_INVOKE_REQ:
				{
				struct smcinvoke_cmd_req scr = { 0};
				argAddr = (uint64_t)getRegValue(REG_ARG_2);

				int rc=  readProcessMemory (Pid,  argAddr, 
					sizeof(struct smcinvoke_cmd_req),
					(char *)&scr);
				(void) rc;
				pos += sprintf(ob + pos, "%sSMCINVOKE_IOCTL_INVOKE_REQ%s - op %d, %d counts, %d args @0x%llx\n",
				gColor? CYAN:"", gColor?NORMAL:"",
				scr.op, scr.counts, scr.argsize, scr.args);

				}
				break;
			case SMCINVOKE_IOCTL_ACCEPT_REQ: 
			pos += sprintf(ob + pos, "%sSMCINVOKE_IOCTL_ACCEPT_REQ%s,...",
				gColor? CYAN:"", gColor?NORMAL:"");
				break;
			case SMCINVOKE_IOCTL_SERVER_REQ:
				pos += sprintf(ob + pos, "%sSMCINVOKE_IOCTL_SERVER_REQ%s,...",
				gColor? CYAN:"", gColor?NORMAL:"");
				break;
			case SMCINVOKE_IOCTL_ACK_LOCAL_OBJ:
				pos += sprintf(ob + pos, "%sSMCINVOKE_IOCTL_ACK_LOCAL_OBJ%s,...",
				gColor? CYAN:"", gColor?NORMAL:"");
				break;
			

		default: 
			pos += sprintf(ob + pos, "Code 0x%lx (unknown - tell J!)", code);
		} // switch code
	}

		
	else {	// ! mine..

			return 2;

	    } // end switch

	} // end if !Exit

   	else{
		if (mine) {

				mine = 0;
 			int rc = (int) getRegValue(REG_ARG_0);

		}


	}
	updateOutputBufferPos(pos);
   	return 0;
} // ioctl




static int init = 0;
__attribute__((constructor)) void _init(void) {
	
	if (init) return;
	init++;	
	fprintf(stderr,"--LOADED smcinvoke plugin, hooking ioctl\n");
	gColor = config_color();

	//ignoreAllSyscalls();

	int rc= registerSyscallHandler ("ioctl", // char *SyscallName, // must exist or you'll get -1 
	        smcinvoke_ioctl,  // syscall_handler_func Handler,     // Your callback, per above
		0, //              int Bitness,     // 32, 64 or 0 (both)
		0);	//      int Flags);      // as per flags, above


}


#if 0

[root@localhost jtrace]# adb shell
sailfish:/ $ echo $$
7719

## Then run jtrace in another window, telling it to follow forks and load your plugin:


sailfish:/ # /data/local/tmp/jtrace64 -jdebug --plugin /data/local/tmp/plugin.so -p 7719 # your shell PID goes here
IN PLUGIN
Chaining handler for open as default
Chaining handler for openat as default
Loaded plugin: /data/local/tmp/plugin.so
...
----IN MY HANDLER for PID 7719 on entry!
FILENAME IS /etc/hosts..
Y IS /init.rc
REDIRECTING /etc/hosts to /init.rc!
----IN MY HANDLER for PID 7719 on exit!


# then in the original shell window, try:
sailfish:/ $ cat /etc/hosts
/system/bin/sh: cat: /init.rc: Permission denied

# :-)

# On x86_64 use the x86 plugin
/x86/jtrace.x86 --plugin ./x86/plugin.so /usr/bin/cat /etc/hosts 





#endif
