#include "jtraceAPI.h"
#include <stdio.h>
#include "colors.h"
#include <sys/ioctl.h>
#include <string.h>
#include <sys/socket.h>
#include <sys/time.h>

#include "statsd.h"

// Sample plugin for JTrace API - for mcDriverDaemon
// ----------------------------
//
// I made the API very simple but (hopefully) effective - q.v. the H file,
// which I've fully documented.
//
// Basically, you create a dylib, 
//
// Please direct any suggestions for improvements, or additional APIs
// you may want to me via NewAndroidBook.com
// 
//



extern int config_color (void);

int gColor ;

int statsd_recvmsg (int Exit, int Pid)
{

   static int mine = 0;
   static	uint64_t msgAddr ;
   

   if (!Exit) {
   	msgAddr = (uint64_t) getRegValue(REG_ARG_1);
 	int fd = (int) getRegValue(REG_ARG_0);
	char *devNode = getFDName(fd);
	if (devNode && strcmp (devNode, "/dev/socket/statsdw") == 0)
		{
		printf("%srecvmsg%s (%d<%s> - ", config_color()?CYAN:"", config_color()?NORMAL:"",fd, devNode);
			mine++;
		}

	}
   else {
	if (!mine) return 0;
	mine = 0;
	int  len = (int) getRegValue(REG_ARG_0);


 	uint64_t msgAddr = (uint64_t) getRegValue(REG_ARG_1);



		uint32_t br = 0;

	       char *msg = getIOVecDataFromMsgHdr (msgAddr, // struct msghdr *MsgHdr, 
		       		       &br, // uint32_t *BytesRead,
				        Pid);
	       	

#pragma pack(1)
	       struct sm {
			uint8_t  logId;
			uint32_t time_a;
			uint32_t time_b;
			uint16_t time_c;
		       	uint32_t tag;
		       	uint64_t elapsedRealTimeNano;
		       	uint32_t alsoNano;
		       	uint32_t code;


		       } *smsg = (struct sm *) msg;

#pragma pack()


#if 0
	msg: logID: 0x5 = 5 Time: 0xd8c260c0-0xb3935f1d.0x455, Tag: 0x73746174 e: 0x1d010703 f:0x5fd6f0cd
	0x00000000: 05 C0 60 C2   D8 1D 5F 93   B3 55 04 74   61 74 73 03     ..`..._..U.tats.
					     24     int32    3       int32
	0x00000010: 07 01 1D CD   F0 D6 5F 18   00 00 00 03   00 00 00 00     ......_.........
		      AID         S  ____len______ ______string ........
	0x00000020: DE 27 00 00   02 14 00 00   00 63 6F 6D   2E 74 6F 70     .'.......com.top
	0x00000030: 6A 6F 68 6E   77 75 2E 6D   61 67 69 73   6B 02 14 00     johnwu.magisk...
	0x00000040: 00 00 63 6F   6D 2E 74 6F   70 6A 6F 68   6E 77 75 2E     ..com.topjohnwu.
	0x00000050: 6D 61 67 69   73 6B 00 FA   03 00 00 01   0B 01 00 00     magisk..........
	0x00000060: 00 00 00 00   00 4E 45 43   54 02 16 00   00 00 63 6F     .....NECT.....co
#endif


   	if (smsg->tag != 0x73746174) {printf("plugin error... or format change?");}
	else
       printf("msg: logID: %d Time: 0x%x-0x%x.0x%hx, Tag: 0x%x elapsed: 0x%llx atom: %s%s%s\n",
 	       smsg->logId,  smsg->time_a, smsg->time_b, smsg->time_c, smsg->tag, smsg->elapsedRealTimeNano, config_color()? RED:"",statsdAtomToText (smsg->code), config_color?NORMAL:"");

	if (config_debug())
	       hexDump((char *) msg, len,  0,1);







	}

		
   	return 0;
} // ioctl




int init = 0;
__attribute__((constructor)) void _init(void) {
	
	if (init) return;
	init++;	
	initAtomProtos();
	fprintf(stderr,"LOADED statsd plugin, hooking recvmsg\n");
	gColor = config_color();


	int rc= registerSyscallHandler ("recvmsg", // char *SyscallName, // must exist or you'll get -1 
	        statsd_recvmsg,  // syscall_handler_func Handler,     // Your callback, per above
		0, //              int Bitness,     // 32, 64 or 0 (both)
		0);	//      int Flags);      // as per flags, above




}


#if 0

[root@localhost jtrace]# adb shell
sailfish:/ $ echo $$
7719

## Then run jtrace in another window, telling it to follow forks and load your plugin:


sailfish:/ # /data/local/tmp/jtrace64 -jdebug --plugin /data/local/tmp/plugin.so -p 7719 # your shell PID goes here
IN PLUGIN
Chaining handler for open as default
Chaining handler for openat as default
Loaded plugin: /data/local/tmp/plugin.so
...
----IN MY HANDLER for PID 7719 on entry!
FILENAME IS /etc/hosts..
Y IS /init.rc
REDIRECTING /etc/hosts to /init.rc!
----IN MY HANDLER for PID 7719 on exit!


# then in the original shell window, try:
sailfish:/ $ cat /etc/hosts
/system/bin/sh: cat: /init.rc: Permission denied

# :-)

# On x86_64 use the x86 plugin
/x86/jtrace.x86 --plugin ./x86/plugin.so /usr/bin/cat /etc/hosts 





#endif
